//ICC-AVR application builder : 29.03.2009 21:25:32
// Target : 2313
// Crystal: 8.0000Mhz

#include <io2313v.h>
#include <macros.h>



//#define LED_delay 150//       
#define    BYTE    unsigned char
#define SET_B(x) |= (1<<x)  
#define CLR_B(x) &=~(1<<x) 
#define INV_B(x) ^=(1<<x) 

//#pragma interrupt_handler timer0_ovf_isr:iv_TIM0_OVF


BYTE h=0; 					      // 
BYTE m=0;						  // 
BYTE s=0;						  // 
BYTE ks=0;     					  // 
//BYTE popravka = 0; 			  //    
BYTE display = 1; 	 			  // 
BYTE vvod=0;   		 			  // ( , )
BYTE th[2] = {0,0}; 			  //  
BYTE tm[2] = {0,0}; 			  //  
BYTE ti=0; 	 				 	  //   
BYTE byDisplay[4] = {0,0,0,0};    //  ,    

BYTE byCharacter[24] = {0b01011111,   //0
                        0b01010000,   //1
 	                	0b00111110,   //2
	               		0b01111100,	  //3 
	                	0b01110001,   //4 
	                	0b01101101,   //5 
	                	0b01101111,   //6
                        0b01011000,   //7 
                        0b01111111,   //8
                        0b01111101,   //9 
                        0b01111011,   //A
                        0b01100111,   //B
                        0b00001111,   //C
                        0b01110110,   //D
                        0b00101111,   //E
                        0b00101011,   //F             
                        0b00000000,   //blank " "  
                        0b00100000,   //-
                        0b01110011,   //H
                        0b00000011,   //I
                        0b00111001,   // 
                        0b00100111,   //t
                        0b01100010,   //n
                        0b00000111    //L
						};

					
void port_init(void)
{
 PORTB = 0x00;  //     = 0      = 0
 DDRB  = 0xFF;  //    
 PORTD = 0x00;  //    D = 0    D  = 0
 DDRD  = 0x7F;  //  D  
}

//TIMER0 initialize - prescale:256
// desired value: 125Hz
// actual value: 125,000Hz (0,0%)
void timer0_init(void)
{
 TCCR0 = 0x00; //stop timer
 TCNT0 = 0x06; //set count
 TCCR0 = 0x04; //start timer
}

//     timer0_ovf_isr
#pragma interrupt_handler timer0_ovf_isr:7 

//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();	  	  			//  
 timer0_init();					// 

 MCUCR = 0x00;
 GIMSK = 0x00;
 TIMSK = 0x02;
 SEI(); //re-enable interrupts
 //all peripherals are now initialized
}

//   
void timer0_ovf_isr(void)
//interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{                   //TIMER0 has overflowed
TCNT0 = 0x06; //   
//TCCR0 = 0x04;
ks++;         //      ks  1
}
// 
void delay(BYTE b1,BYTE b2)
{
BYTE b3,b4;
for (b3=0; b3<b1; b3++)
for (b4=0; b4<b2; b4++);
}

//   
void dannie(BYTE q0,BYTE q1,BYTE q2,BYTE q3)
{
 byDisplay[0]=q0;
 byDisplay[1]=q1;
 byDisplay[2]=q2;
 byDisplay[3]=q3;
}
//   , b1,b2- 
void showdisplay(BYTE b1,BYTE b2)
{
BYTE b3,b4,i; 
for (b3=0; b3<b1; b3++)
for (b4=0; b4<b2; b4++)
        {
		for (i=0; i<4; i++)
				  	   	   {
		 				   PORTB = ~byCharacter[byDisplay[i]];
                		   PORTD SET_B(i);
                		   delay(0,150);
                		   PORTD CLR_B(i);
						   }
		}
	
}
//  
void menu (void)
{
BYTE i,f1;

  DDRB = 0b00000000;	   //    
  PORTB = 0b11111111; 	   //  
  delay(1,200);			   //   
  f1 = (PINB);   		   //     f1
  DDRB = 0b11111111;	   //    
  PORTB = 0b00000000;	   //       
  showdisplay(1,11);	   // 

// ,   SB1    
  if ((f1 == 0b11011111) && (ti == 0))      
  	 	 				{
						if  (vvod == 0) vvod=1;		  	   		    //   
  	 	 		  		else vvod=0; 								//   
								  	   dannie(17,17,17,17);		    //   "----"
									   showdisplay(150,200);
				  					   dannie(h/10,h%10,m/10,m%10); //   
				  					   showdisplay(50,200);
				  		
						}			   
	//  ,   SB2	
  if ((f1 == 0b10111111) && (vvod == 1))
  	 		   	  	 	 				{
										h++;
				  						if (h == 24) h=0;
				  						dannie(h/10,h%10,m/10,m%10);
				  						showdisplay(50,200);
										}
 
    //  ,   SB3		
  if ((f1 == 0b01111111) && (vvod == 1))
  	 	 		  	 	 				{
				 						 m++;
				  						 if (m == 60) m=0;
				  						 dannie(h/10,h%10,m/10,m%10);
				  						 showdisplay(50,200); 
				  						 }	
	//  ":"  "__:" " " " "  SB2									 
  if ((vvod == 0) && (f1 == 0b10111111)) 
  	 		   	  	 	 				 {
										  display++;
										  if (display == 5) display = 1;   	 		//  								 
										  if (display == 1)	dannie(17,12,23,17);	// "-Cl-"
										  if (display == 2)	dannie(16,5,14,12);		// " SEC"
										  if (display == 3)	dannie(21,16,0,22);		// "t 0n"
										  if (display == 4)	dannie(21,0,15,15);     // "t0FF"
										  showdisplay(200,200); 					// 
										 }
  //   "t on"    SB3  
  if ((vvod == 0) && (display == 3) && (f1 == 0b01111111)) PORTD SET_B(4);
  //   "t0FF"    SB3  
  if ((vvod == 0) && (display == 4) && (f1 == 0b01111111)) PORTD CLR_B(4);
  //   __:      
  if ((vvod == 0) && (display == 2) && (f1 == 0b01111111)) s=0;
  //   "-Cl-"   SB3     
  if ((vvod == 0) && (f1 == 0b01111111) && (display == 1))
  	 		   	  	 	 				{
										dannie(17,21,19,17);  // "-tI-"
										showdisplay(150,200);
										ti = 1;
										vvod = 2;
										f1=0xff; 			  //  f1     
										dannie(16,16,0,22);	  // "  0n"
										showdisplay(150,200);
										
										dannie(th[0]/10,th[0]%10,tm[0]/10,tm[0]%10); //   
										//showdisplay(150,200);
										
										}
  //   SB1       ,     										
  if ((f1 == 0b11011111) && (ti == 1)) 
  	 	  	 			 { 	
						 if  (vvod == 2)   			 		 					 //     
						 	 	   	  {
									  vvod=3;									 
									  dannie(16,0,15,15);						 // " 0FF"
									  showdisplay(150,200);
									  
  	 	 		  		 			  dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10);//   
									  showdisplay(150,200);
						 			  }
						 else 		   					   						 //   
						 	  		  {
									  vvod=0;
									  dannie(17,12,23,17);						 // "-Cl-"
									  showdisplay(150,200);
						 		  	  dannie(h/10,h%10,m/10,m%10);				 // 
						 		  	  //dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10);
								  	  ti=0;
								  	  } 			
						 }

			// 	 		
  if ((f1 == 0b10111111) && (vvod == 2))
  	 		   	  	 	 				{
										th[0]++;
				  						if (th[0] == 24) th[0]=0;
				  						dannie(th[0]/10,th[0]%10,tm[0]/10,tm[0]%10);
				  						//showdisplay(50,200);
										}
 
    //    
  if ((f1 == 0b01111111) && (vvod == 2))
  	 	 		  	 	 				{
				 						 tm[0]++;
				  						 if (tm[0] == 60) tm[0]=0;
				  						 dannie(th[0]/10,th[0]%10,tm[0]/10,tm[0]%10);
				  						 //showdisplay(50,200); 
				  						 }					
			// 	 		
  if ((f1 == 0b10111111) && (vvod == 3))
  	 		   	  	 	 				{
										//dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10);
										//showdisplay(1,20);
										th[1]++;
				  						if (th[1] == 24) th[1]=0;
				  						dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10);
				  						//showdisplay(50,200);
										}
 
    //   
  if ((f1 == 0b01111111) && (vvod == 3))
  	 	 		  	 	 				 {
										 //dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10);
										//showdisplay(1,20);
				 						 tm[1]++;
				  						 if (tm[1] == 60) tm[1]=0;
				  						 dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10);
				  						 //showdisplay(50,200); 
				  						 }					

showdisplay(50,200);	
}


void main (void)
{
init_devices(); //    

//ks = 0;
//s = 0;
//m = 0;
//h = 0;
//vvod = 0;
//ti=0;
//display = 1;
while(1)  	   //   
{
if (ks >= 125) //    1
   	   	  	   {
			   if (ks > 125) ks = ks-125;
			   else   		 ks = 0;
			   s++;
			   PORTD INV_B(6);// HL3,HL4  D6 
			   }
//showdisplay(1,11);
if  (s == 60) {s=0; //    1
	   	  	   m++;
			   //p = 0;
			   if (m == 60) //    1
			    	 		{m=0;
							 h++;
							 if (h ==24) h=0;
							 //s=popravka;
							 s=0;
							} 
			   }
//showdisplay(1,11);
//          
if ((display == 1) && (vvod == 0)) dannie(h/10,h%10,m/10,m%10);
if ((display == 2) && (vvod == 0)) dannie(16,16,s/10,s%10);   
if ((display == 3) && (vvod == 0)) dannie(th[0]/10,th[0]%10,tm[0]/10,tm[0]%10); 
if ((display == 4) && (vvod == 0)) dannie(th[1]/10,th[1]%10,tm[1]/10,tm[1]%10); 
// .1   D4      (   HL1)
if ((h == th[0]) && (m == tm[0]) && (vvod == 0) && (s < 3))
   		  	 	   		  	   {
							   // 
							   PORTD SET_B(4);
							   }
// .0   D4      (   HL1)
if ((h == th[1]) && (m == tm[1]) && (vvod == 0) && (s < 3))
   		  	 	   		  	   {
							   // 
							   PORTD CLR_B(4);
							   }
// .1   D5    (  HL2)							   
if ((th[0] != th[1]) || (tm[0] != tm[1])) PORTD SET_B(5);
// .0   D5     (  HL2)
else PORTD CLR_B(5); 

showdisplay(1,11);
menu();			  // 
 
}
}